﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Private fm As FirebaseMessaging
	
End Sub

Sub Service_Create
	fm.Initialize("fm")
	
	
End Sub

Public Sub SubscribeToTopics
	'fm.SubscribeToTopic("general") 'you can subscribe to more topics
	Try
		If Starter.lstTopics.Size = 0 Then
			fm.SubscribeToTopic("general") 'at least this
		Else
			Dim topic As Object, sTopic As String
			For Each topic In Starter.lstTopics
				sTopic = topic
				fm.SubscribeToTopic(sTopic)
			Next
		End If
	Catch
		Log(LastException)
		ToastMessageShow("SubscribeToTopics:" & CRLF & LastException, True)
	End Try
End Sub

Sub Service_Start (StartingIntent As Intent)
	If StartingIntent.IsInitialized Then fm.HandleIntent(StartingIntent)
	Sleep(0)
	Service.StopAutomaticForeground 'remove if not using B4A v8+.
End Sub

Sub fm_MessageArrived (Message As RemoteMessage)
	NewMessage(Message.GetData.Get("title"), Message.GetData.Get("body"))
	Log("Message arrived")
	Log($"Message data: ${Message.GetData}"$)
End Sub

Sub NewMessage(title As String, body As String)
	Dim sName, sTopic As String
	Dim iPos As Int = title.IndexOf(" - ")
	If iPos >= 0 Then
		sTopic = title.SubString2(0, iPos)
		sName = title.SubString(iPos + 3)
	Else
		sTopic = title
		sName = ""
	End If
	Log("Name: " & sName)
	Log("Topic: " & sTopic)
	
	
'	Dim n As Notification
'	n.Initialize
'	n.Icon = "icon"
'	n.SetInfo(title, body, Main)
'	n.Notify(1)

	Starter.b_NewMsgArrived = True
	If sName <> Starter.s_Nickname Then 'Notification
		Dim n As NB6
		n.Initialize("default", title, "DEFAULT").AutoCancel(True).SmallIcon(Starter.smiley)
		n.Build(title, body, "tag1", Main).Notify(1) 'It will be Main (or any other activity) instead of Me if called from a service.
	End If
	SaveMsgToFile(sName, sTopic, body & "<br/>")
End Sub

Sub Service_Destroy

End Sub

Sub AddTopic(topic As String)
	Try
		If topic.Length >= 3 And Starter.lstTopics.IndexOf(topic) < 0 Then 'topic is really new
			fm.SubscribeToTopic(topic)
			Starter.lstTopics.Add(topic)
			'ToastMessageShow(topic & " added", False)
			CallSub(Starter, "SaveTopicList")
		Else
			ToastMessageShow(topic & " allready exists or too short", False)
		End If
	Catch
		ToastMessageShow("AddTopic-Fehler:" & CRLF & LastException, True)
		Log(LastException)
	End Try
End Sub

Sub RemoveTopic(topic As String)
	Dim iIndex As Int = Starter.lstTopics.IndexOf(topic)
	If iIndex >= 0 Then
		fm.UnsubscribeFromTopic(topic)
		Starter.lstTopics.RemoveAt(iIndex)
		CallSub(Starter, "SaveTopicList")
	End If
End Sub

public Sub GetMyToken() As String
	Return fm.Token 'my private token (adr)
End Sub

Sub SaveMsgToFile(name As String, topic As String, msg As String)
	If name <> Starter.s_LastName Then
		Starter.s_LastName = name
		msg = "<br/><i>" & name & ":</i> " & msg
	End If
	
	Dim sDir As String = File.DirInternal
	Dim sFilename As String = topic & ".html"
	Log("Filename: " & "'" & sFilename & "'")
	Log("Nickname: " & "'" & name & "'")
	If File.Exists(sDir, sFilename) = False Then
		File.WriteString(sDir, sFilename, "<h1>Topic: " & topic & "</h1>" & CRLF)
	End If
	Dim Writer As TextWriter
	Writer.Initialize(File.OpenOutput(sDir, sFilename, True))
	Writer.WriteLine(msg)
	Writer.Close
End Sub






